<?php /*

 ocPortal
 Copyright (c) ocProducts, 2004-2012

 See text/EN/licence.txt for full licencing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license		http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright	ocProducts Ltd
 * @package		core_notifications
 */

/**
 * Module page class.
 */
class Module_notifications
{

	/**
	 * Standard modular info function.
	 *
	 * @return ?array	Map of module info (NULL: module is disabled).
	 */
	function info()
	{
		$info=array();
		$info['author']='Chris Graham';
		$info['organisation']='ocProducts';
		$info['hacked_by']=NULL;
		$info['hack_version']=NULL;
		$info['version']=1;
		$info['locked']=false;
		return $info;
	}

	/**
	 * Standard modular entry-point finder function.
	 *
	 * @return ?array	A map of entry points (type-code=>language-code) (NULL: disabled).
	 */
	function get_entry_points()
	{
		if (get_forum_type()=='ocf') return array();
		if (is_guest()) return array();
		return array('misc'=>'NOTIFICATIONS');
	}

	/**
	 * Standard modular run function.
	 *
	 * @return tempcode	The result of execution.
	 */
	function run()
	{
		require_lang('notifications');
		require_code('notifications2');

		$type=get_param('type','misc');

		if ($type=='misc') return $this->overall();
		if ($type=='advanced') return $this->advanced();

		return new ocp_tempcode();
	}

	/**
	 * Show an overall notifications UI.
	 *
	 * @return tempcode	The result of execution.
	 */
	function overall()
	{
		$title=get_screen_title('NOTIFICATIONS');

		$interface=notifications_ui(get_member());

		return do_template('NOTIFICATIONS_MANAGE_SCREEN',array(
			'TITLE'=>$title,
			'INTERFACE'=>$interface,
			'ACTION_URL'=>get_self_url(),
		));
	}

	/**
	 * Show an advanced notifications UI.
	 *
	 * @return tempcode	The result of execution.
	 */
	function advanced()
	{
		$notification_code=get_param('notification_code');

		return notifications_ui_advanced($notification_code);
	}

}


