<?php /*

 ocPortal
 Copyright (c) ocProducts, 2004-2012

 See text/EN/licence.txt for full licencing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license		http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright	ocProducts Ltd
 * @package		calendar
 */

class Hook_stats_calendar
{

	/**
	 * Standard modular run function.
	 *
	 * @return tempcode	The result of execution.
	 */
	function run()
	{
		if (!addon_installed('calendar')) return new ocp_tempcode();

		require_lang('calendar');

		$bits=new ocp_tempcode();
		if (get_option('calendar_show_stats_count_events',true)=='1') $bits->attach(do_template('BLOCK_SIDE_STATS_SUBLINE',array('KEY'=>do_lang_tempcode('EVENTS'),'VALUE'=>integer_format($GLOBALS['SITE_DB']->query_value('calendar_events','COUNT(*)')))));
		if (get_option('calendar_show_stats_count_events_this_week',true)=='1')
		{
			require_code('calendar');
			$events=calendar_matches($GLOBALS['FORUM_DRIVER']->get_guest_id(),true,utctime_to_usertime(time()),utctime_to_usertime(time()+60*60*24*7));
			$bits->attach(do_template('BLOCK_SIDE_STATS_SUBLINE',array('KEY'=>do_lang_tempcode('EVENTS_THIS_WEEK'),'VALUE'=>integer_format(count($events)))));
		}
		if (get_option('calendar_show_stats_count_events_this_month',true)=='1')
		{
			require_code('calendar');
			$events=calendar_matches($GLOBALS['FORUM_DRIVER']->get_guest_id(),true,utctime_to_usertime(time()),utctime_to_usertime(time()+60*60*24*31));
			$bits->attach(do_template('BLOCK_SIDE_STATS_SUBLINE',array('KEY'=>do_lang_tempcode('EVENTS_THIS_MONTH'),'VALUE'=>integer_format(count($events)))));
		}
		if (get_option('calendar_show_stats_count_events_this_year',true)=='1')
		{
			require_code('calendar');
			$events=calendar_matches($GLOBALS['FORUM_DRIVER']->get_guest_id(),true,utctime_to_usertime(time()),utctime_to_usertime(time()+60*60*24*365));
			$bits->attach(do_template('BLOCK_SIDE_STATS_SUBLINE',array('KEY'=>do_lang_tempcode('EVENTS_THIS_YEAR'),'VALUE'=>integer_format(count($events)))));
		}
		if ($bits->is_definitely_empty()) return new ocp_tempcode();
		$section=do_template('BLOCK_SIDE_STATS_SECTION',array('SECTION'=>do_lang_tempcode('CALENDAR'),'CONTENT'=>$bits));

		return $section;
	}

}


