<?php /*

 ocPortal
 Copyright (c) ocProducts, 2004-2012

 See text/EN/licence.txt for full licencing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license		http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright	ocProducts Ltd
 * @package		ocf_forum
 */

class Hook_ocf_topics
{

	/**
	 * Standard modular info function.
	 *
	 * @return ?array	Map of module info (NULL: module is disabled).
	 */
	function info()
	{
		if (get_forum_type()!='ocf') return NULL; else ocf_require_all_forum_stuff();

		require_lang('ocf');

		$info=array();
		$info['title']=do_lang_tempcode('FORUM_TOPICS');
		$info['description']=do_lang_tempcode('DESCRIPTION_CACHE_TOPICS');
		$info['type']='cache';

		return $info;
	}

	/**
	 * Standard modular run function.
	 *
	 * @return tempcode	Results
	 */
	function run()
	{
		if (get_forum_type()!='ocf') return new ocp_tempcode(); else ocf_require_all_forum_stuff();

		if (function_exists('set_time_limit')) @set_time_limit(0);

		// Topics and posts
		$start=0;
		do
		{
			$topics=$GLOBALS['FORUM_DB']->query_select('f_topics',array('id','t_forum_id'),NULL,'',500,$start);
			foreach ($topics as $topic)
			{
				require_code('ocf_posts_action2');
				ocf_force_update_topic_cacheing($topic['id'],NULL,true,true);

				// NB: p_cache_forum_id must not be intval'd as may be null
				if (is_null($topic['t_forum_id'])) $topic['t_forum_id']=NULL;
				$GLOBALS['FORUM_DB']->query('UPDATE '.$GLOBALS['FORUM_DB']->get_table_prefix().'f_posts SET p_cache_forum_id='.(is_null($topic['t_forum_id'])?'NULL':strval($topic['t_forum_id'])).' WHERE p_topic_id='.(is_null($topic['id'])?'NULL':strval($topic['id'])));
			}

			$start+=500;
		}
		while (array_key_exists(0,$topics));

		// Polls
		$start=0;
		do
		{
			$polls=$GLOBALS['FORUM_DB']->query_select('f_polls',array('id'),NULL,'',500,$start);
			foreach ($polls as $poll)
			{
				$total_votes=$GLOBALS['FORUM_DB']->query_value('f_poll_votes','COUNT(*)',array('pv_poll_id'=>$poll['id']));
				$GLOBALS['FORUM_DB']->query_update('f_polls',array('po_cache_total_votes'=>$total_votes),array('id'=>$poll['id']),'',1);

				$answers=$GLOBALS['FORUM_DB']->query_select('f_poll_answers',array('id'),array('pa_poll_id'=>$poll['id']));
				foreach ($answers as $answer)
				{
					$votes=$GLOBALS['FORUM_DB']->query_value('f_poll_votes','COUNT(*)',array('pv_answer_id'=>$answer['id'],'pv_poll_id'=>$poll['id']));
					$GLOBALS['FORUM_DB']->query_update('f_poll_answers',array('pa_cache_num_votes'=>$votes),array('id'=>$answer['id']),'',1);
				}
			}

			$start+=500;
		}
		while (array_key_exists(0,$polls));

		return new ocp_tempcode();
	}

}


