<?php /*

 ocPortal
 Copyright (c) ocProducts, 2004-2012

 See text/EN/licence.txt for full licencing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license		http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright	ocProducts Ltd
 * @package		ecommerce
 */

class Hook_members_ecommerce
{

	/**
	 * Standard modular run function.
	 *
	 * @param  MEMBER		The ID of the member we are getting link hooks for
	 * @return array		List of tuples for results. Each tuple is: type,title,url
	 */
	function run($member_id)
	{
		if (!addon_installed('ecommerce')) return array();

		require_lang('ecommerce');
		$modules=array();

		if ($GLOBALS['SITE_DB']->query_value('invoices','COUNT(*)',array('i_member_id'=>$member_id))!=0)
			$modules[]=array('views',do_lang_tempcode('MY_INVOICES'),build_url(array('page'=>'invoices','type'=>'misc','id'=>$member_id),get_module_zone('invoices')));

		if ($GLOBALS['SITE_DB']->query_value('subscriptions','COUNT(*)',array('s_member_id'=>$member_id))!=0)
			$modules[]=array('views',do_lang_tempcode('MY_SUBSCRIPTIONS'),build_url(array('page'=>'subscriptions','type'=>'misc','id'=>$member_id),get_module_zone('subscriptions')));

		if (has_actual_page_access(get_member(),'admin_ecommerce',get_module_zone('admin_ecommerce')))
		{
			$username=$GLOBALS['FORUM_DRIVER']->get_username($member_id);
			$modules[]=array('views',do_lang_tempcode('CREATE_INVOICE'),build_url(array('page'=>'admin_invoices','type'=>'ad','to'=>$username),get_module_zone('admin_invoices')));
		}

		return $modules;
	}

}


