<?php /*

 ocPortal
 Copyright (c) ocProducts, 2004-2012

 See text/EN/licence.txt for full licencing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license		http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright	ocProducts Ltd
 * @package		occle
 */

class Hook_addon_registry_occle
{
	/**
	 * Get a list of file permissions to set
	 *
	 * @return array			File permissions to set
	 */
	function get_chmod_array()
	{
		return array();
	}

	/**
	 * Get the version of ocPortal this addon is for
	 *
	 * @return float			Version number
	 */
	function get_version()
	{
		return ocp_version_number();
	}

	/**
	 * Get the description of the addon
	 *
	 * @return string			Description of the addon
	 */
	function get_description()
	{
		return 'A command-line environment for managing your website, designed for Linux/Unix lovers.';
	}

	/**
	 * Get a mapping of dependency types
	 *
	 * @return array			File permissions to set
	 */
	function get_dependencies()
	{
		return array(
			'requires'=>array(),
			'recommends'=>array(),
			'conflicts_with'=>array()
		);
	}

	/**
	 * Get a list of files that belong to this addon
	 *
	 * @return array			List of files
	 */
	function get_file_list()
	{
		return array(
			'sources/hooks/systems/config_default/bottom_show_occle_button.php',
			'sources/hooks/systems/config_default/occle_chat_announce.php',
			'themes/default/images/pagepics/occle.png',
			'sources/hooks/modules/admin_occle_fs/.htaccess',
			'sources/hooks/modules/admin_occle_notifications/.htaccess',
			'sources/hooks/systems/addon_registry/occle.php',
			'sources/hooks/modules/admin_occle_commands/antispam_check.php',
			'sources/hooks/modules/admin_occle_commands/set_comment_forum.php',
			'data/modules/admin_occle/.htaccess',
			'OCCLE_HELP.tpl',
			'OCCLE_LS.tpl',
			'OCCLE_MAIN.tpl',
			'JAVASCRIPT_OCCLE.tpl',
			'OCCLE_ARRAY.tpl',
			'OCCLE_ARRAY_ELEMENT.tpl',
			'OCCLE_BOX.tpl',
			'OCCLE_CHAT_NOTIFICATION.tpl',
			'OCCLE_COMMAND.tpl',
			'OCCLE_COMMANDS.tpl',
			'OCCLE_EDIT.tpl',
			'OCCLE_ENTRY_POINTS.tpl',
			'OCCLE_FIND_CODES.tpl',
			'OCCLE_MAIN_SCREEN.tpl',
			'OCCLE_NOTIFICATION.tpl',
			'OCCLE_OCCLECHAT_NOTIFICATION.tpl',
			'OCCLE_OCF_NOTIFICATION.tpl',
			'OCCLE_PT_NOTIFICATION.tpl',
			'OCCLE_RSS.tpl',
			'OCCLE_RSS_ITEM.tpl',
			'OCCLE_USERS_ONLINE.tpl',
			'OCCLE_WHOIS.tpl',
			'JAVASCRIPT_BUTTON_OCCLE.tpl',
			'adminzone/pages/modules/admin_occle.php',
			'occle.css',
			'themes/default/images/bigicons/occle.png',
			'themes/default/images/footer/occle.png',
			'themes/default/images/footer/occle_off.png',
			'data/modules/admin_occle/admin_occlesample_script',
			'data/modules/admin_occle/index.html',
			'data/modules/admin_occle/sample_script',
			'data/modules/admin_occle/test_script',
			'data/occle.php',
			'lang/EN/occle.ini',
			'sources/hooks/modules/admin_occle_commands/.htaccess',
			'sources/hooks/modules/admin_occle_commands/alien_check.php',
			'sources/hooks/modules/admin_occle_commands/directory_sizes.php',
			'sources/hooks/modules/admin_occle_commands/mysql_table_sizes.php',
			'sources/hooks/modules/admin_occle_commands/db_search.php',
			'sources/hooks/modules/admin_occle_commands/append.php',
			'sources/hooks/modules/admin_occle_commands/ban_ip.php',
			'sources/hooks/modules/admin_occle_commands/ban_member.php',
			'sources/hooks/modules/admin_occle_commands/bsod.php',
			'sources/hooks/modules/admin_occle_commands/phpinfo.php',
			'sources/hooks/modules/admin_occle_commands/call.php',
			'sources/hooks/modules/admin_occle_commands/cat.php',
			'sources/hooks/modules/admin_occle_commands/cd.php',
			'sources/hooks/modules/admin_occle_commands/clear.php',
			'sources/hooks/modules/admin_occle_commands/clear_caches.php',
			'sources/hooks/modules/admin_occle_commands/closed.php',
			'sources/hooks/modules/admin_occle_commands/commands.php',
			'sources/hooks/modules/admin_occle_commands/cp.php',
			'sources/hooks/modules/admin_occle_commands/cpdir.php',
			'sources/hooks/modules/admin_occle_commands/date.php',
			'sources/hooks/modules/admin_occle_commands/echo.php',
			'sources/hooks/modules/admin_occle_commands/edit.php',
			'sources/hooks/modules/admin_occle_commands/exit.php',
			'sources/hooks/modules/admin_occle_commands/feedback.php',
			'sources/hooks/modules/admin_occle_commands/find.php',
			'sources/hooks/modules/admin_occle_commands/find_codes.php',
			'sources/hooks/modules/admin_occle_commands/find_entry_points.php',
			'sources/hooks/modules/admin_occle_commands/find_function.php',
			'sources/hooks/modules/admin_occle_commands/fix_perms.php',
			'sources/hooks/modules/admin_occle_commands/grep.php',
			'sources/hooks/modules/admin_occle_commands/help.php',
			'sources/hooks/modules/admin_occle_commands/index.html',
			'sources/hooks/modules/admin_occle_commands/ls.php',
			'sources/hooks/modules/admin_occle_commands/mkdir.php',
			'sources/hooks/modules/admin_occle_commands/mv.php',
			'sources/hooks/modules/admin_occle_commands/mvdir.php',
			'sources/hooks/modules/admin_occle_commands/occlechat.php',
			'sources/hooks/modules/admin_occle_commands/passwd.php',
			'sources/hooks/modules/admin_occle_commands/pwd.php',
			'sources/hooks/modules/admin_occle_commands/read.php',
			'sources/hooks/modules/admin_occle_commands/reset.php',
			'sources/hooks/modules/admin_occle_commands/rm.php',
			'sources/hooks/modules/admin_occle_commands/rmdir.php',
			'sources/hooks/modules/admin_occle_commands/time.php',
			'sources/hooks/modules/admin_occle_commands/users_online.php',
			'sources/hooks/modules/admin_occle_commands/version.php',
			'sources/hooks/modules/admin_occle_commands/whoami.php',
			'sources/hooks/modules/admin_occle_commands/whois.php',
			'sources/hooks/modules/admin_occle_commands/write.php',
			'sources/hooks/modules/admin_occle_commands/database_upgrade.php',
			'sources/hooks/modules/admin_occle_commands/check_perms.php',
			'sources/hooks/modules/admin_occle_commands/integrity_check.php',
			'sources/hooks/modules/admin_occle_fs/bin.php',
			'sources/hooks/modules/admin_occle_fs/database.php',
			'sources/hooks/modules/admin_occle_fs/etc.php',
			'sources/hooks/modules/admin_occle_fs/index.html',
			'sources/hooks/modules/admin_occle_fs/raw.php',
			'sources/hooks/modules/admin_occle_fs/root.php',
			'sources/hooks/modules/admin_occle_notifications/index.html',
			'sources/hooks/modules/admin_occle_notifications/occlechat.php',
			'sources/hooks/systems/do_next_menus/occle.php',
			'sources/hooks/systems/snippets/occle.php',
			'sources/occle.php'
		);
	}


	/**
	 * Get mapping between template names and the method of this class that can render a preview of them
	 *
	 * @return array			The mapping
	 */
	function tpl_previews()
	{
		return array(
			'OCCLE_MAIN.tpl'=>'administrative__occle_main',
			'OCCLE_MAIN_SCREEN.tpl'=>'administrative__occle_main_screen',
			'OCCLE_COMMAND.tpl'=>'administrative__occle_command',
			'OCCLE_ARRAY_ELEMENT.tpl'=>'administrative__occle_array',
			'OCCLE_ARRAY.tpl'=>'administrative__occle_array',
			'OCCLE_NOTIFICATION.tpl'=>'administrative__occle_command',
			'OCCLE_HELP.tpl'=>'administrative__occle_help',
			'OCCLE_BOX.tpl'=>'administrative__occle_box',
			'OCCLE_COMMANDS.tpl'=>'administrative__occle_commands',
			'OCCLE_RSS_ITEM.tpl'=>'administrative__occle_rss',
			'OCCLE_RSS.tpl'=>'administrative__occle_rss',
			'OCCLE_EDIT.tpl'=>'administrative__occle_edit',
			'OCCLE_USERS_ONLINE.tpl'=>'administrative__occle_users_online',
			'OCCLE_FIND_CODES.tpl'=>'administrative__occle_find_codes',
			'OCCLE_WHOIS.tpl'=>'administrative__occle_whois',
			'OCCLE_ENTRY_POINTS.tpl'=>'administrative__occle_entry_points',
			'OCCLE_LS.tpl'=>'administrative__occle_ls',
			'OCCLE_CHAT_NOTIFICATION.tpl'=>'administrative__occle_chat_notification',
			'OCCLE_OCCLECHAT_NOTIFICATION.tpl'=>'administrative__occle_occlechat_notification',
			'OCCLE_OCF_NOTIFICATION.tpl'=>'administrative__occle_ocf_notification',
			'OCCLE_PT_NOTIFICATION.tpl'=>'administrative__occle_pt_notification'
		);
	}

	/**
	 * Get a preview(s) of a (group of) template(s), as a full standalone piece of HTML in Tempcode format.
	 * Uses sources/lorem.php functions to place appropriate stock-text. Should not hard-code things, as the code is intended to be declaritive.
	 * Assumptions: You can assume all Lang/CSS/Javascript files in this addon have been pre-required.
	 *
	 * @return array			Array of previews, each is Tempcode. Normally we have just one preview, but occasionally it is good to test templates are flexible (e.g. if they use IF_EMPTY, we can test with and without blank data).
	 */
	function tpl_preview__administrative__occle_main()
	{
		return array(
			lorem_globalise(do_lorem_template('OCCLE_MAIN', array(
				'COMMANDS'=>lorem_phrase(),
				'SUBMIT_URL'=>placeholder_url(),
				'page'=>lorem_phrase(),
				'PROMPT'=>lorem_phrase()
			)), NULL, '', true)
		);
	}

	/**
	 * Get a preview(s) of a (group of) template(s), as a full standalone piece of HTML in Tempcode format.
	 * Uses sources/lorem.php functions to place appropriate stock-text. Should not hard-code things, as the code is intended to be declaritive.
	 * Assumptions: You can assume all Lang/CSS/Javascript files in this addon have been pre-required.
	 *
	 * @return array			Array of previews, each is Tempcode. Normally we have just one preview, but occasionally it is good to test templates are flexible (e.g. if they use IF_EMPTY, we can test with and without blank data).
	 */
	function tpl_preview__administrative__occle_main_screen()
	{
		$content=do_lorem_template('OCCLE_MAIN', array(
			'SUBMIT_URL'=>placeholder_url(),
			'PROMPT'=>lorem_phrase(),
			'COMMANDS'=>lorem_phrase()
		));

		return array(
			lorem_globalise(do_lorem_template('OCCLE_MAIN_SCREEN', array(
				'TITLE'=>lorem_title(),
				'CONTENT'=>$content
			)), NULL, '', true)
		);
	}

	/**
	 * Get a preview(s) of a (group of) template(s), as a full standalone piece of HTML in Tempcode format.
	 * Uses sources/lorem.php functions to place appropriate stock-text. Should not hard-code things, as the code is intended to be declaritive.
	 * Assumptions: You can assume all Lang/CSS/Javascript files in this addon have been pre-required.
	 *
	 * @return array			Array of previews, each is Tempcode. Normally we have just one preview, but occasionally it is good to test templates are flexible (e.g. if they use IF_EMPTY, we can test with and without blank data).
	 */
	function tpl_preview__administrative__occle_command()
	{
		$notifications=do_lorem_template('OCCLE_NOTIFICATION', array(
			'SECTION'=>lorem_phrase(),
			'TYPE'=>lorem_phrase(),
			'NOTIFICATION_CONTENT'=>lorem_phrase()
		));

		return array(
			lorem_globalise(do_lorem_template('OCCLE_COMMAND', array(
				'NOTIFICATIONS'=>$notifications,
				'METHOD'=>lorem_phrase(),
				'STDOUT'=>lorem_phrase(),
				'STDHTML'=>lorem_phrase(),
				'STDCOMMAND'=>lorem_word_2(),
				'STDERR'=>lorem_phrase()
			)), NULL, '', true)
		);
	}

	/**
	 * Get a preview(s) of a (group of) template(s), as a full standalone piece of HTML in Tempcode format.
	 * Uses sources/lorem.php functions to place appropriate stock-text. Should not hard-code things, as the code is intended to be declaritive.
	 * Assumptions: You can assume all Lang/CSS/Javascript files in this addon have been pre-required.
	 *
	 * @return array			Array of previews, each is Tempcode. Normally we have just one preview, but occasionally it is good to test templates are flexible (e.g. if they use IF_EMPTY, we can test with and without blank data).
	 */
	function tpl_preview__administrative__occle_array()
	{
		$elements=do_lorem_template('OCCLE_ARRAY_ELEMENT', array(
			'KEY'=>lorem_phrase(),
			'VALUE'=>lorem_phrase()
		));

		return array(
			lorem_globalise(do_lorem_template('OCCLE_ARRAY', array(
				'ELEMENTS'=>$elements
			)), NULL, '', true)
		);
	}

	/**
	 * Get a preview(s) of a (group of) template(s), as a full standalone piece of HTML in Tempcode format.
	 * Uses sources/lorem.php functions to place appropriate stock-text. Should not hard-code things, as the code is intended to be declaritive.
	 * Assumptions: You can assume all Lang/CSS/Javascript files in this addon have been pre-required.
	 *
	 * @return array			Array of previews, each is Tempcode. Normally we have just one preview, but occasionally it is good to test templates are flexible (e.g. if they use IF_EMPTY, we can test with and without blank data).
	 */
	function tpl_preview__administrative__occle_help()
	{
		return array(
			lorem_globalise(do_lorem_template('OCCLE_HELP', array(
				'INTRODUCTION'=>lorem_phrase(),
				'OPTIONS'=>placeholder_array(),
				'PARAMETERS'=>placeholder_array()
			)), NULL, '', true)
		);
	}

	/**
	 * Get a preview(s) of a (group of) template(s), as a full standalone piece of HTML in Tempcode format.
	 * Uses sources/lorem.php functions to place appropriate stock-text. Should not hard-code things, as the code is intended to be declaritive.
	 * Assumptions: You can assume all Lang/CSS/Javascript files in this addon have been pre-required.
	 *
	 * @return array			Array of previews, each is Tempcode. Normally we have just one preview, but occasionally it is good to test templates are flexible (e.g. if they use IF_EMPTY, we can test with and without blank data).
	 */
	function tpl_preview__administrative__occle_box()
	{
		return array(
			lorem_globalise(do_lorem_template('OCCLE_BOX', array(
				'HTML'=>lorem_sentence_html()
			)), NULL, '', true)
		);
	}

	/**
	 * Get a preview(s) of a (group of) template(s), as a full standalone piece of HTML in Tempcode format.
	 * Uses sources/lorem.php functions to place appropriate stock-text. Should not hard-code things, as the code is intended to be declaritive.
	 * Assumptions: You can assume all Lang/CSS/Javascript files in this addon have been pre-required.
	 *
	 * @return array			Array of previews, each is Tempcode. Normally we have just one preview, but occasionally it is good to test templates are flexible (e.g. if they use IF_EMPTY, we can test with and without blank data).
	 */
	function tpl_preview__administrative__occle_commands()
	{
		return array(
			lorem_globalise(do_lorem_template('OCCLE_COMMANDS', array(
				'COMMANDS'=>placeholder_array()
			)), NULL, '', true)
		);
	}

	/**
	 * Get a preview(s) of a (group of) template(s), as a full standalone piece of HTML in Tempcode format.
	 * Uses sources/lorem.php functions to place appropriate stock-text. Should not hard-code things, as the code is intended to be declaritive.
	 * Assumptions: You can assume all Lang/CSS/Javascript files in this addon have been pre-required.
	 *
	 * @return array			Array of previews, each is Tempcode. Normally we have just one preview, but occasionally it is good to test templates are flexible (e.g. if they use IF_EMPTY, we can test with and without blank data).
	 */
	function tpl_preview__administrative__occle_rss()
	{
		$content=do_lorem_template('OCCLE_RSS_ITEM', array(
			'FULL_URL'=>placeholder_url(),
			'NEWS_TITLE'=>lorem_phrase(),
			'DATE'=>placeholder_time(),
			'SUMMARY'=>lorem_paragraph()
		));

		return array(
			lorem_globalise(do_lorem_template('OCCLE_RSS', array(
				'TITLE'=>lorem_phrase(),
				'CONTENT'=>$content
			)), NULL, '', true)
		);
	}

	/**
	 * Get a preview(s) of a (group of) template(s), as a full standalone piece of HTML in Tempcode format.
	 * Uses sources/lorem.php functions to place appropriate stock-text. Should not hard-code things, as the code is intended to be declaritive.
	 * Assumptions: You can assume all Lang/CSS/Javascript files in this addon have been pre-required.
	 *
	 * @return array			Array of previews, each is Tempcode. Normally we have just one preview, but occasionally it is good to test templates are flexible (e.g. if they use IF_EMPTY, we can test with and without blank data).
	 */
	function tpl_preview__administrative__occle_edit()
	{
		return array(
			lorem_globalise(do_lorem_template('OCCLE_EDIT', array(
				'UNIQ_ID'=>placeholder_random(),
				'FILE'=>lorem_phrase(),
				'SUBMIT_URL'=>placeholder_url(),
				'FILE_CONTENTS'=>lorem_sentence()
			)), NULL, '', true)
		);
	}

	/**
	 * Get a preview(s) of a (group of) template(s), as a full standalone piece of HTML in Tempcode format.
	 * Uses sources/lorem.php functions to place appropriate stock-text. Should not hard-code things, as the code is intended to be declaritive.
	 * Assumptions: You can assume all Lang/CSS/Javascript files in this addon have been pre-required.
	 *
	 * @return array			Array of previews, each is Tempcode. Normally we have just one preview, but occasionally it is good to test templates are flexible (e.g. if they use IF_EMPTY, we can test with and without blank data).
	 */
	function tpl_preview__administrative__occle_users_online()
	{
		$memb=array();
		foreach (placeholder_array() as $k=>$v)
		{
			$memb[$v]=$k;
		}
		return array(
			lorem_globalise(do_lorem_template('OCCLE_USERS_ONLINE', array(
				'MEMBERS'=>$memb,
				'GUESTS'=>placeholder_number()
			)), NULL, '', true)
		);
	}

	/**
	 * Get a preview(s) of a (group of) template(s), as a full standalone piece of HTML in Tempcode format.
	 * Uses sources/lorem.php functions to place appropriate stock-text. Should not hard-code things, as the code is intended to be declaritive.
	 * Assumptions: You can assume all Lang/CSS/Javascript files in this addon have been pre-required.
	 *
	 * @return array			Array of previews, each is Tempcode. Normally we have just one preview, but occasionally it is good to test templates are flexible (e.g. if they use IF_EMPTY, we can test with and without blank data).
	 */
	function tpl_preview__administrative__occle_find_codes()
	{
		return array(
			lorem_globalise(do_lorem_template('OCCLE_FIND_CODES', array(
				'FILES'=>placeholder_array()
			)), NULL, '', true)
		);
	}

	/**
	 * Get a preview(s) of a (group of) template(s), as a full standalone piece of HTML in Tempcode format.
	 * Uses sources/lorem.php functions to place appropriate stock-text. Should not hard-code things, as the code is intended to be declaritive.
	 * Assumptions: You can assume all Lang/CSS/Javascript files in this addon have been pre-required.
	 *
	 * @return array			Array of previews, each is Tempcode. Normally we have just one preview, but occasionally it is good to test templates are flexible (e.g. if they use IF_EMPTY, we can test with and without blank data).
	 */
	function tpl_preview__administrative__occle_whois()
	{
		return array(
			lorem_globalise(do_lorem_template('OCCLE_WHOIS', array(
				'STATS'=>lorem_phrase(),
				'IP_LIST'=>placeholder_list_item(),
				'ID'=>placeholder_id(),
				'IP'=>placeholder_ip(),
				'NAME'=>lorem_word()
			)), NULL, '', true)
		);
	}

	/**
	 * Get a preview(s) of a (group of) template(s), as a full standalone piece of HTML in Tempcode format.
	 * Uses sources/lorem.php functions to place appropriate stock-text. Should not hard-code things, as the code is intended to be declaritive.
	 * Assumptions: You can assume all Lang/CSS/Javascript files in this addon have been pre-required.
	 *
	 * @return array			Array of previews, each is Tempcode. Normally we have just one preview, but occasionally it is good to test templates are flexible (e.g. if they use IF_EMPTY, we can test with and without blank data).
	 */
	function tpl_preview__administrative__occle_entry_points()
	{
		$points=array();
		foreach (placeholder_array() as $k=>$v)
		{
			$points[$v]=$k;
		}
		return array(
			lorem_globalise(do_lorem_template('OCCLE_ENTRY_POINTS', array(
				'ENTRY_POINTS'=>$points
			)), NULL, '', true)
		);
	}

	/**
	 * Get a preview(s) of a (group of) template(s), as a full standalone piece of HTML in Tempcode format.
	 * Uses sources/lorem.php functions to place appropriate stock-text. Should not hard-code things, as the code is intended to be declaritive.
	 * Assumptions: You can assume all Lang/CSS/Javascript files in this addon have been pre-required.
	 *
	 * @return array			Array of previews, each is Tempcode. Normally we have just one preview, but occasionally it is good to test templates are flexible (e.g. if they use IF_EMPTY, we can test with and without blank data).
	 */
	function tpl_preview__administrative__occle_ls()
	{
		return array(
			lorem_globalise(do_lorem_template('OCCLE_LS', array(
				'DIRECTORY'=>lorem_phrase(),
				'DIRECTORIES'=>placeholder_array(),
				'FILES'=>placeholder_array()
			)), NULL, '', true)
		);
	}

	/**
	 * Get a preview(s) of a (group of) template(s), as a full standalone piece of HTML in Tempcode format.
	 * Uses sources/lorem.php functions to place appropriate stock-text. Should not hard-code things, as the code is intended to be declaritive.
	 * Assumptions: You can assume all Lang/CSS/Javascript files in this addon have been pre-required.
	 *
	 * @return array			Array of previews, each is Tempcode. Normally we have just one preview, but occasionally it is good to test templates are flexible (e.g. if they use IF_EMPTY, we can test with and without blank data).
	 */
	function tpl_preview__administrative__occle_chat_notification()
	{
		require_lang('chat');

		$rooms=array();
		foreach (placeholder_array() as $k=>$v)
		{
			$rooms[$v]=$k;
		}
		return array(
			lorem_globalise(do_lorem_template('OCCLE_CHAT_NOTIFICATION', array(
				'MESSAGE_COUNT'=>placeholder_number(),
				'ROOMS'=>$rooms
			)), NULL, '', true)
		);
	}

	/**
	 * Get a preview(s) of a (group of) template(s), as a full standalone piece of HTML in Tempcode format.
	 * Uses sources/lorem.php functions to place appropriate stock-text. Should not hard-code things, as the code is intended to be declaritive.
	 * Assumptions: You can assume all Lang/CSS/Javascript files in this addon have been pre-required.
	 *
	 * @return array			Array of previews, each is Tempcode. Normally we have just one preview, but occasionally it is good to test templates are flexible (e.g. if they use IF_EMPTY, we can test with and without blank data).
	 */
	function tpl_preview__administrative__occle_occlechat_notification()
	{
		return array(
			lorem_globalise(do_lorem_template('OCCLE_OCCLECHAT_NOTIFICATION', array(
				'MESSAGE_COUNT'=>placeholder_number(),
				'MESSAGES'=>placeholder_array()
			)), NULL, '', true)
		);
	}

	/**
	 * Get a preview(s) of a (group of) template(s), as a full standalone piece of HTML in Tempcode format.
	 * Uses sources/lorem.php functions to place appropriate stock-text. Should not hard-code things, as the code is intended to be declaritive.
	 * Assumptions: You can assume all Lang/CSS/Javascript files in this addon have been pre-required.
	 *
	 * @return array			Array of previews, each is Tempcode. Normally we have just one preview, but occasionally it is good to test templates are flexible (e.g. if they use IF_EMPTY, we can test with and without blank data).
	 */
	function tpl_preview__administrative__occle_ocf_notification()
	{
		$topics=array();
		foreach (placeholder_array() as $val)
		{
			$topics[]=array(
				'_loop_var'=>placeholder_url(),
				'_loop_key'=>lorem_word()
			);
		}
		return array(
			lorem_globalise(do_lorem_template('OCCLE_OCF_NOTIFICATION', array(
				'TOPICS'=>$topics
			)), NULL, '', true)
		);
	}

	/**
	 * Get a preview(s) of a (group of) template(s), as a full standalone piece of HTML in Tempcode format.
	 * Uses sources/lorem.php functions to place appropriate stock-text. Should not hard-code things, as the code is intended to be declaritive.
	 * Assumptions: You can assume all Lang/CSS/Javascript files in this addon have been pre-required.
	 *
	 * @return array			Array of previews, each is Tempcode. Normally we have just one preview, but occasionally it is good to test templates are flexible (e.g. if they use IF_EMPTY, we can test with and without blank data).
	 */
	function tpl_preview__administrative__occle_pt_notification()
	{
		$topics=array();
		foreach (placeholder_array() as $val)
		{
			$topics[]=array(
				'_loop_var'=>placeholder_url(),
				'_loop_key'=>lorem_word()
			);
		}
		return array(
			lorem_globalise(do_lorem_template('OCCLE_PT_NOTIFICATION', array(
				'TOPICS'=>$topics
			)), NULL, '', true)
		);
	}
}
