<?php /*

 ocPortal
 Copyright (c) ocProducts, 2004-2012

 See text/EN/licence.txt for full licencing information.


 NOTE TO PROGRAMMERS:
   Do not edit this file. If you need to make changes, save your changed file to the appropriate *_custom folder
   **** If you ignore this advice, then your website upgrades (e.g. for bug fixes) will likely kill your changes ****

*/

/**
 * @license		http://opensource.org/licenses/cpal_1.0 Common Public Attribution License
 * @copyright	ocProducts Ltd
 * @package		news
 */

class Hook_content_meta_aware_news_category
{

	/**
	 * Standard modular info function for content_meta_aware hooks. Allows progmattic identification of ocPortal entity model (along with db_meta table contents).
	 *
	 * @return ?array	Map of award content-type info (NULL: disabled).
	 */
	function info()
	{
		return array(
			'content_type_label'=>'news:NEWS_CATEGORY',

			'table'=>'news_categories',
			'id_field'=>'id',
			'id_field_numeric'=>true,
			'parent_category_field'=>NULL,
			'parent_category_meta_aware_type'=>'news_category',
			'title_field'=>'nc_title',
			'title_field_dereference'=>true,

			'is_category'=>true,
			'is_entry'=>false,
			'seo_type_code'=>'news_category',
			'feedback_type_code'=>NULL,
			'permissions_type_code'=>'news', // NULL if has no permissions
			'view_pagelink_pattern'=>'_SEARCH:news:misc:_WILD',
			'edit_pagelink_pattern'=>'_SEARCH:cms_news:_ec:_WILD',
			'view_category_pagelink_pattern'=>'_SEARCH:news:misc:_WILD',
			'support_url_monikers'=>true,
			'search_hook'=>NULL,
			'submitter_field'=>NULL,
			'add_time_field'=>NULL,
			'edit_time_field'=>NULL,
			'validated_field'=>NULL,

			'addon_name'=>'news',

			'module'=>'news',
		);
	}

}
